module page_layer;

private {
    import cairo_support;
}

public {
    import icanvas;
}

interface Page {
}

class PageLayer : Layer, Page {
    this(in string name) {
        super(name);
        mPageGeometry = Rectangle(Point.DEFAULT, Vector(210.0, 297.0));
        //mPageGeometry = Rectangle(Point.DEFAULT, Vector(100.0, 100.0));
    }

    override Rectangle bounds() const {
        return mPageGeometry;
    }

    override void draw(const Viewport viewport, in Rectangle damage,
                       Context model_cr, Context pixel_cr) const {
        // Make the paper white, with a border

        model_cr.save; {
            model_cr.setSourceRgba(1.0, 1.0, 1.0, 1.0);
            rectangle(model_cr, mPageGeometry);
            model_cr.fill;
        } model_cr.restore;

        model_cr.save; {
            model_cr.setSourceRgba(0.0, 0.0, 0.0, 1.0);
            rectangle(model_cr, mPageGeometry);
            model_cr.stroke;
        } model_cr.restore;
    }

    private {
        Rectangle mPageGeometry;
    }
}
